{{set . "title" "Import"}}
{{template "header.html" .}}

<header class="hero-unit">
    <div class="container">
        <div class="row">
            <div class="hero-text">
                <h1>Edit Import</h1>
            </div>
        </div>
    </div>
</header>

<div class="container">
    <div class="row">
        <div class="col-md-12">
        {{template "flash.html" .}}
        </div>
        <div class="col-md-12">
            <form method="POST" action="{{if .i.ID}}{{url "Import.Update"}}{{else}}{{url "Import.Create"}}{{end}}">
            {{with $field := field "i.ID" .}}
                <input type="hidden" id="{{$field.ID}}" name="ID" value="{{$field.Value}}">
            {{end}}
                <div class="form-group">
                {{with $field := field "i.Name" .}}
                    <label for="{{$field.ID}}">Name * </label>
                    <input type="text" id="{{$field.ID}}" name="Name" value="{{$field.Value}}"
                           class="{{$field.ErrorClass}} form-control">
                    <span class="error">{{$field.Error}}</span>

                {{end}}
                </div>
                <div class="form-group">
                {{with $field := field "i.Status" .}}
                    <label for="{{$field.ID}}" class="custom-control custom-checkbox">Status *
                        <input type="checkbox" id="{{$field.ID}}" name="Status" value="1"
                               class="{{$field.ErrorClass}} custom-control-input"
                        {{if $field.Value}}
                        {{if (eq $field.Value true)}}checked="checked"
                        {{end}}
                        {{end}}>
                        <span class="custom-control-indicator"></span>
                    </label>
                    <span class="error">{{$field.Error}}</span>

                {{end}}
                </div>
                <div class="form-group">
                {{with $field := field "i.SupplierID" .}}
                    <label for="{{$field.ID}}">SupplierID * </label>
                    <select id="{{$field.ID}}" name="SupplierID" class="{{$field.ErrorClass}} form-control col-md-6">
                        <option value="">Select supplier</option>
                    {{range $v := $.suppliers}}
                        <option value="{{$v.ID}}" {{if $field.Value}}
                        {{if (eq $field.Value $v.ID)}}selected="selected"
                        {{end}}
                        {{end}}>{{$v.Name}}
                        </option>
                    {{end}}
                    </select>

                    <span class="error">{{$field.Error}}</span>
                {{end}}
                </div>
                <div class="form-group">
                {{with $field := field "i.WarehouseID" .}}
                    <label for="{{$field.ID}}">WarehouseID * </label>
                    <select id="{{$field.ID}}" name="WarehouseID" class="{{$field.ErrorClass}} form-control col-md-6">
                        <option value="">Select warehouse</option>
                    {{range $v := $.warehouses}}
                        <option value="{{$v.ID}}" {{if $field.Value}}
                        {{if (eq $field.Value $v.ID)}}selected="selected"
                        {{end}}
                        {{end}}>{{$v.Name}}
                        </option>
                    {{end}}
                    </select>
                    <span class="error">{{$field.Error}}</span>

                {{end}}
                </div>
                <div class="form-group">
                {{with $field := field "i.FileName" .}}
                    <label for="{{$field.ID}}">FileName * </label>
                    <input type="text" id="{{$field.ID}}" name="FileName" value="{{$field.Value}}"
                           class="{{$field.ErrorClass}} form-control">
                    <span class="error">{{$field.Error}}</span>

                {{end}}
                </div>

                <div class="form-group">
                {{with $field := field "i.HeaderRow" .}}
                    <label for="{{$field.ID}}">Header Row * </label>
                    <input type="number" id="{{$field.ID}}" name="HeaderRow" value="{{$field.Value}}"
                           class="{{$field.ErrorClass}} form-control col-md-6">
                    <span class="error">{{$field.Error}}</span>
                {{end}}
                </div>

                <div class="form-group">
                {{with $field := field "i.UpdateType" .}}
                    <label for="{{$field.ID}}">Update type * </label>
                    <select id="{{$field.ID}}" name="UpdateType" class="{{$field.ErrorClass}} form-control col-md-6">
                        <option value="">Select option</option>
                        <option value="update" {{if $field.Value}}{{if eq $field.Value "update"}}selected="selected" {{end}}{{end}}>
                            Update existing only
                        </option>
                        <option value="new">Add new only</option>
                        <option value="update_new">Add new and update existing</option>
                        <option value="delete">Delete products in the list</option>
                    </select>
                    <span class="error">{{$field.Error}}</span>
                {{end}}
                </div>

                <div class="form-group row">
                    <label class="col-12">Qty modifier * </label>
                    <div class="col-md-4">
                    {{with $field := field "i.QtyLimit" .}}
                        <input type="number" step="0.01" min="0" id="{{$field.ID}}" name="QtyLimit"
                               value="{{$field.Value}}"
                               class="{{$field.ErrorClass}} form-control" placeholder="Enter qty modifier">
                        <span class="error">{{$field.Error}}</span>
                    {{end}}
                    </div>
                    <div class="col-md-4">
                    {{with $field := field "i.QtyModType" .}}
                        <select name="QtyModType" class="{{$field.ErrorClass}} form-control">
                            <option value="">Select modifier type</option>
                            <option value="fixed"{{if $field.Value}}
                            {{if (eq $field.Value "fixed")}}selected="selected"
                            {{end}}
                            {{end}}>Fixed
                            </option>
                            <option value="per_cent"{{if $field.Value}}
                            {{if (eq $field.Value "per_cent")}}selected="selected"
                            {{end}}
                            {{end}}>%, Per cent
                            </option>
                        </select>
                        <span class="error">{{$field.Error}}</span>
                    {{end}}
                    </div>
                    <div class="input-group col-md-4">
                    {{with $field := field "i.QtyModMethod" .}}
                        <select name="QtyModMethod" class="{{$field.ErrorClass}} form-control">
                            <option value="">Select modification method</option>
                            <option value="add"{{if $field.Value}}
                            {{if (eq $field.Value "add")}}selected="selected"
                            {{end}}
                            {{end}}>+, Addition
                            </option>
                            <option value="sub"{{if $field.Value}}
                            {{if (eq $field.Value "sub")}}selected="selected"
                            {{end}}
                            {{end}}>-, Subtraction
                            </option>
                            <option value="mul"{{if $field.Value}}
                            {{if (eq $field.Value "mul")}}selected="selected"
                            {{end}}
                            {{end}}>*, Multiplication
                            </option>
                            <option value="div"{{if $field.Value}}
                            {{if (eq $field.Value "div")}}selected="selected"
                            {{end}}
                            {{end}}>/, Division
                            </option>
                        </select>
                        <span class="error">{{$field.Error}}</span>
                    {{end}}
                    </div>
                </div>

                <div class="form-group row">
                    <label class="col-12">Price modifier * </label>
                    <div class="col-md-4">
                    {{with $field := field "i.PriceModifier" .}}
                        <input type="number" step="0.01" min="0" id="{{$field.ID}}" name="PriceModifier"
                               value="{{$field.Value}}" class="{{$field.ErrorClass}} form-control"
                               placeholder="Enter price modifier">
                        <span class="error">{{$field.Error}}</span>
                    {{end}}
                    </div>
                    <div class="col-md-4">
                    {{with $field := field "i.PriceModType" .}}
                        <select name="PriceModType" class="{{$field.ErrorClass}} form-control">
                            <option value="">Select modifier type</option>
                            <option value="fixed"{{if $field.Value}}
                            {{if (eq $field.Value "fixed")}}selected="selected"
                            {{end}}
                            {{end}}>Fixed
                            </option>
                            <option value="per_cent"{{if $field.Value}}
                            {{if (eq $field.Value "per_cent")}}selected="selected"
                            {{end}}
                            {{end}}>%, Per cent
                            </option>
                        </select>
                        <span class="error">{{$field.Error}}</span>
                    {{end}}
                    </div>
                    <div class="input-group col-md-4">
                    {{with $field := field "i.PriceModMethod" .}}
                        <select name="PriceModMethod" class="{{$field.ErrorClass}} form-control">
                            <option value="">Select modification method</option>
                            <option value="add" {{if $field.Value}}
                            {{if (eq $field.Value "add")}}selected="selected"
                            {{end}}
                            {{end}}>+, Addition
                            </option>
                            <option value="sub"{{if $field.Value}}
                            {{if (eq $field.Value "sub")}}selected="selected"
                            {{end}}
                            {{end}}>-, Subtraction
                            </option>
                            <option value="mul"{{if $field.Value}}
                            {{if (eq $field.Value "mul")}}selected="selected"
                            {{end}}
                            {{end}}>*, Multiplication
                            </option>
                            <option value="div"{{if $field.Value}}
                            {{if (eq $field.Value "div")}}selected="selected"
                            {{end}}
                            {{end}}>/, Division
                            </option>
                        </select>
                        <span class="error">{{$field.Error}}</span>
                    {{end}}
                    </div>
                </div>

                <div class="row">
                    <label class="col col-form-label">Field Mapping * </label>
                </div>

                <div class="attributes">
                {{with $field := field "i.Mapping" .}}
                {{range $i, $v := $field.Value}}
                    <div class="form-row">
                        <input type="hidden" name="Mapping.{{$i}}.ID" value="{{$v.ID}}" class="form-control">
                        <div class="form-group col-md-5">
                            <select name="Mapping.{{$i}}.Key" class="{{$field.ErrorClass}} col form-control">
                                <option value="">Select option</option>
                            {{range $a := $.attrs}}
                                <option value="{{$a.Code}}" {{if $v.Key}}
                                {{if (eq $a.Code $v.Key)}}selected="selected"
                                {{end}}
                                {{end}}>{{$a.Name}}</option>
                            {{end}}
                            </select>
                        </div>
                        <div class="form-group col-md-5">
                            <input type="text" name="Mapping.{{$i}}.Value" value="{{$v.Value}}"
                                   class="{{$field.ErrorClass}} col form-control">
                            <span class="error">{{$field.Error}}</span>
                        </div>
                        <div class="col-md-2">
                            <span class="btn btn-danger delete-attribute">Delete</span>
                            <span class="btn btn-primary add-attribute">Add</span>
                        </div>
                    </div>
                {{end}}
                {{end}}
                </div>

                <input type="submit" class="btn btn-success" value="Save import"/>
            </form>
        </div>
    </div>
</div>

<script>
    $(document).ready(function () {
        $('.attributes').on('click', '.delete-attribute', function (e) {
            $parent = $(e.target).closest('.form-row');
            // id = $parent.find('input[type=hidden]').val();
            // $.post('/import/delete-mapping', {id: id}, function (data) {
            //     console.log(data);
            // });
            $parent.remove();
            $.each($('.form-row'), function (i, v) {
                $elements = $(v).find(".form-control");
                $.each($elements, function (j, el) {
                    attributeReplace(el, "name", i);
                });
            });
        });

        $('.attributes').on('click', '.add-attribute', function (e) {
            $parent = $(e.target).closest('.form-row');
            $clone = $parent.clone();
            inputs = $clone.find(".form-control");
            total = $('.attributes .form-row').length;
            $.each(inputs, function (i, v) {
                $(v).attr("value", "");
                attributeReplace(v, "name", total);
            });

            $clone.appendTo('.attributes');
        });

        function attributeReplace(el, attribute, index) {
            attr = $(el).attr(attribute).replace(/(.*).(\d+).(.*)/g, "$1." + index + ".$3")
            $(el).attr(attribute, attr);
        }
    });
</script>

{{template "footer.html" .}}